package  
{
	import flash.geom.ColorTransform;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author tony
	 */
	public class Player extends Entity 
	{
		public var image: Image = new Image(Assets.img_player);
		
		public var x_vel: Number = 0;
		public var y_vel: Number = 0;
		
		
		public function Player() 
		{
			image.centerOO();
			//image.centerOrigin();
			//image.x = -16;
			//image.y = -16;
			setHitbox(20, 20);
			
			type = "player";
			layer = -2;
			
			x = FP.bounds.right / 2 - 100;
			y = FP.bounds.bottom / 2;
			
			graphic = image;
		}
		
		public var old_x: Number;
		public var old_y: Number;
		public var is_colliding : Boolean = false;
		//public var same_x_count : int = 0;
		//public var same_y_count : int = 0;
		
		override public function update():void 
		{
			super.update();
			
			//movement keys
			if (Input.check(Key.W)) y_vel -= .2;
			if (Input.check(Key.S)) y_vel += .2;
			
			if (Input.check(Key.D)) x_vel += .2;
			if (Input.check(Key.A)) x_vel -= .2;
			
			x_vel *= .9;
			y_vel *= .9;
			
			
			x += x_vel;
			y += y_vel;
			
			if (x < 0) x = 0;
			if (x > FP.bounds.right) x = FP.bounds.right;
			if (y < 0) y = 0;
			if (y > FP.bounds.bottom) y = FP.bounds.bottom;
			
			
			
			var dart_list:Array = [];
			world.getType("dart", dart_list);
			
			for each (var td:TempleDart in dart_list)
			{
				if (this.distanceFrom(td) < 25)
				{
					
					var ang:Number = FP.angle(x, y, td.x, td.y);
					td.vel.x += Math.cos(ang * 0.01745) * .3;
					td.vel.y -= Math.sin(ang * 0.01745) * .3;
					//td.moveTowards(x, y, -3);
				}
			}
		}
	
		override public function render():void 
		{
			super.render();
		}
	}

}