package  
{
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	
	/**
	 * ...
	 * @author tony
	 */
	public class Proxy extends Entity 
	{
		public var target:Point = new Point(0, 0);
		public var x_vel: Number = 0;
		public var y_vel: Number = 0;
		public static var danger:Sfx = new Sfx(Assets.snd_danger);
		
		public var timer:int = 0;
		
		public var health: int = 10;
		
		public function Proxy() 
		{
			type = "proxy";
			
			var top: Point = new Point(FP.bounds.right / 2, 50);
			var bottom: Point = new Point(FP.bounds.right / 2, FP.bounds.bottom - 50);
			var right: Point = new Point(FP.bounds.right - 50, FP.bounds.bottom / 2);
			var left: Point = new Point(50, FP.bounds.bottom / 2);
			
			var pos: Point = FP.choose(top, bottom, right, left);
			x = pos.x;
			y = pos.y;
			//x = FP.rand(FP.bounds.right);
			//y = FP.rand(FP.bounds.bottom);
			target.x = FP.rand(FP.bounds.right);
			target.y = FP.rand(FP.bounds.bottom);
			
			graphic = new Image(Assets.img_proxy);
			(graphic as Image).centerOO();
		}
		
		override public function update():void 
		{
			super.update();
			
			
			if (x < 0)
			{
				x = 5;
				x_vel *= -1;
			}
			if (x > FP.bounds.right)
			{
				x = FP.bounds.right - 5;
				x_vel *= -1;
			}
			if (y < 0)
			{
				y = 5;
				y_vel *= -1;
			}
			if (y > FP.bounds.bottom)
			{
				y = FP.bounds.bottom - 5;
				y_vel *= -1;
			}
			
			
			var ang:Number = FP.angle(x, y, target.x, target.y);
			x_vel += Math.cos(ang * 0.01745) * .05;
			y_vel -= Math.sin(ang * 0.01745) * .05;
			
			x_vel *= .9;
			y_vel *= .9;
			
			x += x_vel;
			y += y_vel;
			
			timer++;
			if (timer > 120)
			{
				timer = 0;
				target.x = FP.rand(FP.bounds.right);
				target.y = FP.rand(FP.bounds.bottom);
			}
			
			
			var dart_list:Array = [];
			world.getType("dart", dart_list);
			
			for each (var td:TempleDart in dart_list)
			{
				if (this.distanceFrom(td) < 25)
				{
					if (!danger.playing)
						danger.play();
					
					ang = FP.angle(x, y, td.x, td.y);
					td.vel.x += Math.cos(ang * 0.01745) * .5;
					td.vel.y -= Math.sin(ang * 0.01745) * .5;
					//td.moveTowards(x, y, -3);
				}
			}
			
			//FP.stepTowards(this, target.x, target.y, 2);
			//moveTowards(target.x, target.y, 2);
			//this.move
		}
		
	}

}