package  
{
	import flash.geom.ColorTransform;
	import flash.geom.Point;
	import flash.sampler.NewObjectSample;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Draw;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author tony
	 */
	public class Scut extends Entity 
	{
		public var x_vel:Number = 0;
		public var y_vel:Number = 0;
		
		public static var danger:Sfx = new Sfx(Assets.snd_danger);
		
		public function Scut() 
		{
			type = "scut";
			graphic = new Image(Assets.img_scut);
			(graphic as Image).centerOO();
			
			var top: Point = new Point(FP.bounds.right / 2, 50);
			var bottom: Point = new Point(FP.bounds.right / 2, FP.bounds.bottom - 50);
			var right: Point = new Point(FP.bounds.right - 50, FP.bounds.bottom / 2);
			var left: Point = new Point(50, FP.bounds.bottom / 2);
			
			var pos: Point = FP.choose(top, bottom, right, left);
			x = pos.x;
			y = pos.y;
			//x = FP.rand(FP.bounds.right);
			//y = FP.rand(FP.bounds.bottom);
			
			var ang:Number = FP.rand(360);
			(graphic as Image).angle = ang;
			x_vel += Math.cos(ang * 0.01745) * 1;
			y_vel -= Math.sin(ang * 0.01745) * 1;
		}
		
		override public function update():void 
		{
			super.update();
			
			x += x_vel;
			y += y_vel;
			if (x < 0)
			{
				x = 5;
				x_vel *= -1;
			}
			if (x > FP.bounds.right)
			{
				x = FP.bounds.right - 5;
				x_vel *= -1;
			}
			if (y < 0)
			{
				y = 5;
				y_vel *= -1;
			}
			if (y > FP.bounds.bottom)
			{
				y = FP.bounds.bottom - 5;
				y_vel *= -1;
			}
			
			var ang:Number = FP.angle(0, 0, x_vel, y_vel);;
			(graphic as Image).angle = ang;
			//x_vel = Math.cos(ang * 0.01745) * 1;
			//y_vel = Math.sin(ang * 0.01745) * 1;
			
			
			var dart_list:Array = [];
			world.getType("dart", dart_list);
			
			for each (var td:TempleDart in dart_list)
			{
				if (this.distanceFrom(td) < 25)
				{
					if (!danger.playing)
						danger.play();
					ang = FP.angle(x, y, td.x, td.y);
					td.vel.x += Math.cos(ang * 0.01745) * .5;
					td.vel.y -= Math.sin(ang * 0.01745) * .5;
					//td.moveTowards(x, y, -3);
				}
			}
			
			
			
		}
		
	}

}